﻿@page
@using Microsoft.Extensions.Localization;
@inject IStringLocalizer StringLocalizer;
@model Canyon.GM.Panel.Areas.Articles.Pages.ListModel
@{
    ViewData[TITLE] = StringLocalizer.GetString("ArticleList");
}

<div class="mb-2">
    <a class="btn btn-primary" asp-area="Articles" asp-page="/Index">
        <i class="fa-solid fa-plus" aria-hidden="true"></i>
        @StringLocalizer["NewArticle"]
    </a>
</div>

@foreach (var categoryType in Model.ArticleCategoriesTypes)
{
    <table id="tblArticleCategoryType@(categoryType.Id)" class="table table-sm table-stripped table-hover table-bordered table-responsive caption-top">
        <caption>@StringLocalizer[categoryType.Name]</caption>
        <thead>
            <tr>
                <th>@StringLocalizer["ArticleID"]</th>
                <th>@StringLocalizer["ArticleName"]</th>
                <th>@StringLocalizer["ArticleEditor"]</th>
                <th>@StringLocalizer["ArticleLanguage"]</th>
                <th>@StringLocalizer["ArticlePublishDate"]</th>
                <th></th>
            </tr>
        </thead>
        @foreach (var cat in categoryType.Categories)
        {
            <tbody class="table-group-divider">
                <tr>
                    <td class="text-center" colspan="6">@StringLocalizer[cat.Name]</td>
                </tr>
            </tbody>
            <tbody class="table-group-divider">
                @foreach (var article in cat.Articles)
                {
                    <tr>
                        <td>@article.Id</td>
                        <td>@article.Title</td>
                        <td>@article.Writer</td>
                        <td>
                            @foreach (var language in article.Locales)
                            {
                                <a asp-area="Articles" asp-page="/Index" asp-route-ArticleId="@article.Id" asp-route-Locale="@language">@language</a> <br />
                            }
                        </td>
                        <td>@article.PublishDate</td>
                        <td>
                            <a href="#" onclick="onSortUp(this);"><i class="fa fa-sort-up" aria-hidden="true"></i></a>&nbsp;<a href="#" onclick="onSortDown(this);"><i class="fa fa-sort-down" aria-hidden="true"></i></a>
                        </td>
                    </tr>
                }
            </tbody>

        }
    </table>
    <hr />
}

@section Scripts
    {
    <script>
        const SortUrl = '@Url.Action("ChangeArticleOrder", "Articles")';

        function onSortUp(el) {
            event.preventDefault();

            const row = $(el).parent().parent();
            const table = $(row).parent().parent();
            const rowIndex = $(table).find('tr').index(row);
            const id = $(el).parent().parent().find('td')[0].innerText;

            if (rowIndex <= 1) {
                return;
            }

            $.ajax({
                url: SortUrl,
                type: 'PATCH',
                headers: {
                    'Content-Type': 'application/json'
                },
                data: JSON.stringify({
                    PostId: id,
                    Order: 0
                }),
                success: function (result) {
                    $(row).prev().before(row);
                },
                error: function (error) {
                    console.log(error);
                }
            });
        }

        function onSortDown(el) {
            event.preventDefault();

            const row = $(el).parent().parent();
            const table = $(row).parent().parent();
            const rowIndex = $(table).find('tr').index(row);
            const rowCount = $(table).find('tr').length - 1;
            const id = $(el).parent().parent().find('td')[0].innerText;

            if (rowIndex >= rowCount) {
                return;
            }

            $.ajax({
                url: SortUrl,
                type: 'PATCH',
                headers: {
                    'Content-Type': 'application/json'
                },
                data: JSON.stringify({
                    PostId: id,
                    Order: 1
                }),
                success: function (result) {
                    $(row).next().after(row);
                },
                error: function (error) {
                    console.log(error);
                }
            });
        }

    </script>
}